<?php
class ModelExtensionModuleSmsRangine extends Model {
	private function getTemplates($type, $store_id) { 
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "smsrangine_template st LEFT JOIN " . DB_PREFIX . "smsrangine_template_message stm ON st.sms_template_id = stm.sms_template_id WHERE type = '" . $this->db->escape($type) . "' AND store_id = '" . (int)$store_id . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "'");
		
		return $query->rows;
	}
	
	private function getSearch($type) {
		if ($type == 'register') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{password}'
			);
		} elseif ($type == 'affiliate') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}'
			);
		} elseif ($type == 'affiliate_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{commission}',
				'{total_commission}'
			);
		} elseif ($type == 'affiliate_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'forgotten') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{password}'
			);
		} elseif ($type == 'order') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{comment_table}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		} elseif ($type == 'reward') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{points}',
				'{total_points}'
			);
		} elseif ($type == 'account_approve') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}'
			);
		} elseif ($type == 'account_transaction') {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{credits}',
				'{total_credits}'
			);
		} else {
			$search = array(
				'{firstname}',
				'{lastname}',
				'{email}',
				'{telephone}',
				'{order_id}',
				'{date_added}',
				'{payment_method}',
				'{shipping_method}',
				'{ip}',
				'{comment_table}',
				'{payment_address}',
				'{shipping_address}',
				'{products}'
			);
		}
	
		return $search;
	}
	
	public function parseSMS($type, $store_id, $number, $replace) {
	
		$number = preg_replace('/[^0-9]/', '', $number);
		
		$country_code = '98';
		
		$templates = $this->getTemplates($type, $store_id);
	
		
		$template_data = false;
		foreach ($templates as $template) {
			/* $countries = json_decode($template['country'], true);
			
			if ($countries && in_array($country_code, $countries)) { */
				$template_data = $template;
				
			/* 	break;
			} */
		}
	    
		if ($template_data && !empty($template_data['message'])) {
			$search = $this->getSearch($type);
			
			$message = strip_tags(str_replace($search, $replace, html_entity_decode($template_data['message'])));
			
			$this->sendSMS($number, $message);
			
			$numbers = explode(',', $template_data['bcc']);
			foreach ($numbers as $number) {
				if ($number) {
					$this->sendSMS($number, $message);
				}
			}
		} else {
			return false;
		}
	}
	
	private function sendSMS($receiver, $message) {
		$response = false;
		$username = $this->config->get('smsrangine_auth_key');
		$password = $this->config->get('smsrangine_auth_secret');
		$from     = $this->config->get('smsrangine_default_senderid');

		if ( empty( $username ) || empty( $password ) || empty( $from ) ) {
			return $response;
		}

		$massage  = strip_tags($message);
		$to       = $receiver;

		if (substr( $massage, 0, 11 ) === "patterncode"){
			$splited = explode(';', $massage);
			$patterncodeArray = explode(':', $splited[0]);
			$patterncode = $patterncodeArray[1];
			unset($splited[0]);
			$input_data = array();
			foreach($splited as $parm){
			  $splited_parm = explode(':', $parm);
			  $input_data[$splited_parm[0]] = $splited_parm[1];
			}
			$url = "http://sms.rangine.ir/patterns/pattern?username=".$username."&password=".urlencode($password)."&from=$from&to=".json_encode($to)."&input_data=".urlencode(json_encode($input_data))."&pattern_code=$patterncode";
			$param = array();
			$handler = curl_init($url);             
			curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
			curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
			curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
			$result = curl_exec($handler);

			if ( ! empty( $result ) && is_numeric( $result ) ) {
				$response = true;
			}

			return $response;
		}else{
			$url = "sms.rangine.ir/services.jspd";
			$param = array
						(
							'uname'=>$username,
							'pass'=>$password,
							'from'=>$from,
							'message'=>$massage,
							'to'=>json_encode($to),
							'op'=>'send'
						);
						
			$handler = curl_init($url);             
			curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
			curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
			curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
			$result = curl_exec($handler);
			
			$result2 = json_decode($result);
			$res_code = $result2[0];
			$res_data = $result2[1];
			 if ($res_code == '0'){
				$response = true;
			}
			return $response;
		}
	}
}